from enum import Enum


class Experiment(str, Enum):
    """Types of modules."""

    CLEVR = "clevr"
    CLEVR_DIALOG = "clevr_dialog"
    MNIST_DIALOG = "mnist_dialog"

    @staticmethod
    def list():
        return list(map(lambda e: e.value, Experiment))


class UnsupportedExperimentError(ValueError):
    """Custom error that is raised when a given experiment is not supported/recognized."""

    def __init__(self, experiment: str) -> None:
        super().__init__(f"Unexpected experiment: {experiment}.")
