import json
import logging
import os
import random


def get_max_sample(args, samples):
    logging.info(f"Generated {len(samples)} samples")
    if args.max_samples is not None and len(samples) > args.max_samples:
        samples = random.sample(samples, args.max_samples)
        logging.info(f"Reduced to {len(samples)} samples")
    return samples


def write(args, data, module_name):
    # create directory
    output_dir = os.path.join(args.output_dir, module_name)
    os.makedirs(output_dir, exist_ok=True)

    output_filename = args.scenes_basename + ".json"
    out_path = os.path.join(output_dir, output_filename)
    with open(out_path, "w") as f:
        json.dump(data, f)
