#!/usr/bin/env python

from torch.utils.data import Dataset

from nmn.utils.config import load_json


class ModuleDataset(Dataset):
    def __init__(self, **kwargs):
        super(ModuleDataset, self).__init__()
        self.images_dir = kwargs.get("images")

        scenes = load_json(kwargs.get("scenes"))
        self.samples = scenes["samples"]
        if "category" in scenes:
            self.category = scenes["category"]
        self.config = kwargs.get("config")
        self.device = kwargs.get("device")

    def __len__(self):
        return len(self.samples)
