#!/usr/bin/env python

import numpy as np
import torch
import torch.nn as nn


class Unique(nn.Module):
    def __init__(self, count):
        super(Unique, self).__init__()
        self.count = count

    def forward(self, src):
        log_probs = self.count(src)
        prob, n = torch.max(log_probs, dim=1)
        prob, n = prob.item(), n.item()
        return n == 1, np.exp(prob)


class MoreThanOne(nn.Module):
    def __init__(self, count_module):
        super(MoreThanOne, self).__init__()
        self.count = count_module

    def forward(self, src):
        log_probs = self.count(src)
        prob, n = torch.max(log_probs, dim=1)
        prob, n = prob.item(), n.item()
        return n >= 2, np.exp(prob)


class Exists(nn.Module):
    def __init__(self, count_module):
        super(Exists, self).__init__()
        self.count = count_module

    def forward(self, src):
        log_probs = self.count(src)
        prob, n = torch.max(log_probs, dim=1)
        prob, n = prob.item(), n.item()
        return n >= 1, np.exp(prob)
