#!/usr/bin/env python

import torch.nn as nn


class Relate(nn.Module):
    def __init__(self, relate_modules, embedder):
        super(Relate, self).__init__()
        self.relate_modules = relate_modules
        self.embedder = embedder

    def forward(self, src):
        relationship = src["relationship"]
        if type(self.relate_modules) is dict:
            relate = self.relate_modules[relationship]
            return relate(src)
        else:
            relationship = self.embedder(relationship)
            relate = self.relate_modules
            return relate(
                {
                    "image": src["image"],
                    "mask": src["mask"],
                    "relationship": relationship,
                }
            )
