#!/usr/bin/env python

import torch
import torch.nn as nn

# The following modules operate on masks.


class MaskIntersection(nn.Module):
    def forward(self, att1, att2):
        return torch.min(att1, att2)


class MaskUnion(nn.Module):
    def forward(self, att1, att2):
        return torch.max(att1, att2)


class MaskDifference(nn.Module):
    def __init__(self):
        super(MaskDifference, self).__init__()

    def forward(self, att1, att2):
        x = att1 - att2
        x[x < 0] = 0  # do not allow negative values
        return x
