#!/usr/bin/env python

import torch.nn as nn

from nmn.modules.subsymbolic.segmentation.u_net import UNet


def get_semantic_segmentation_architecture(**kwargs):
    architecture = kwargs.get("architecture")
    if architecture == "UNet":
        return UNet(**kwargs)
    else:
        raise ValueError(
            f"Unexpected semantic segmentation architecture: {architecture}."
        )


class SemanticSegmentation(nn.Module):
    def __init__(self, **kwargs):
        super(SemanticSegmentation, self).__init__()
        self.segmenter = get_semantic_segmentation_architecture(**kwargs)

    def forward(self, src):
        attention = self.segmenter(src)
        return attention
