from enum import Enum


class ModuleType(str, Enum):
    """Types of modules."""

    CONTEXT = "context"
    COUNT = "count"
    QUERY = "query"
    FIND = "find"
    RELATE = "relate"
    IMMEDIATE_RELATE = "immediate_relate"
    EXTREME_RELATE = "extreme_relate"

    @staticmethod
    def list():
        return list(map(lambda t: t.value, ModuleType))


class UnsupportedModuleTypeError(ValueError):
    """Custom error that is raised when a given module type is not supported/recognized."""

    def __init__(self, module_type: str) -> None:
        super().__init__(f"Unexpected module type: {module_type}.")
