#!/usr/bin/env python

from nmn.options.options import Options


class ServerOptions(Options):
    def __init__(self):
        super(ServerOptions, self).__init__()

        self.parser.add_argument("--images-dir", required=True, help="Path to the images folder")
        self.parser.add_argument("--server-host", default="127.0.0.1")
        self.parser.add_argument("--server-port", default=8888, type=int)
        self.parser.add_argument("--specificity", default="concept", type=str, choices=["category", "concept"])
        self.parser.add_argument(
            "--iou-threshold",
            default=0.9,
            type=float,
            help="Threshold for when attentions are considered equal",
        )
        self.parser.add_argument(
            "--num-flask-processes",
            default=1,
            type=int,
            help="Number of processes to spawn for handling requests",
        )
        self.parser.add_argument(
            "--num-torch-processes",
            default=1,
            type=int,
            help="Number of processes to spawn for PyTorch",
        )
        self.parser.add_argument(
            "--use-logging",
            default=1,
            type=int,
            choices=[0, 1],
            help="Logging can be turned off as it leads to huge files",
        )
