#!/usr/bin/env python

from nmn.options.options import Options, none_or_value


class TestOptions(Options):
    """
    TestOptions are the command line arguments for
    evaluating modules separately
    """

    def __init__(self):
        super(TestOptions, self).__init__()
        self.parser.add_argument(
            "--checkpoint", required=True, type=str, help="Path to checkpoint to load"
        )
        self.parser.add_argument("--batch_size", default=128, type=int)
        self.parser.add_argument(
            "--max_samples_test",
            type=none_or_value,
            default=None,
            help="amount of samples to use for testing",
        )
        self.parser.add_argument(
            "--output_csv",
            type=str,
            default="output/test_accuracy.csv",
            help="append accuracy line to this CSV file",
        )
        self.parser.add_argument(
            "--save_num_batches",
            default=0,
            type=int,
            help="How many batches to save the predictions",
        )
        self.parser.add_argument(
            "--predictions_pkl",
            type=str,
            default="output/predictions.pkl",
            help="If save predictions, path to save them",
        )
