#!/usr/bin/env python


class FlaskException(Exception):
    """
    General class for throwing Exceptions
    """

    status_code = 400

    def __init__(self, message, status_code=None, payload=None):
        super(FlaskException, self).__init__()
        self.message = message
        if status_code is not None:
            self.status_code = status_code
        self.payload = payload

    def to_dict(self):
        rv = dict(self.payload or ())
        rv["message"] = self.message
        return rv


class MissingKeyException(FlaskException):
    """Exception for a missing key in the HTTP request"""

    def __init__(self, message, status_code=None, payload=None):
        super(MissingKeyException, self).__init__(message, status_code, payload)


class MissingCaseException(FlaskException):
    """Exception for an unknown case in the primitive evaluation"""

    def __init__(self, message, status_code=None, payload=None):
        super(MissingCaseException, self).__init__(message, status_code, payload)
