#!/usr/bin/env python

import torch.nn as nn

from nmn.modules.utils.module_type import ModuleType, UnsupportedModuleTypeError


def get_loss_fn(module_type):
    if module_type == ModuleType.CONTEXT:
        return nn.BCELoss()
    elif module_type == ModuleType.COUNT:
        return nn.NLLLoss(reduction="mean")
    elif module_type == ModuleType.FIND:
        return nn.BCELoss()
    elif module_type == ModuleType.QUERY:
        return nn.NLLLoss(reduction="mean")
    elif module_type == ModuleType.RELATE:
        return nn.BCELoss()
    elif module_type == ModuleType.EXTREME_RELATE:
        return nn.BCELoss()
    elif module_type == ModuleType.IMMEDIATE_RELATE:
        return nn.BCELoss()
    else:
        raise UnsupportedModuleTypeError(module_type)
