#!/bin/bash

POSITIONAL_ARGS=()

while [[ $# -gt 0 ]]; do
  case $1 in
    -u|--user)
      USERNAME="$2"
      shift
      shift
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
    *)
      POSITIONAL_ARGS+=("$1") # save positional arg
      shift # past argument
      ;;
  esac
done

set -- "${POSITIONAL_ARGS[@]}" # restore positional parameters

echo "Fetching CLEVR from the corpora SVN..."
dest="data/clevr/"
zip="data/clevr/CLEVR-v1.0.zip"

brew install wget --quiet
mkdir -p "$dest"
wget --user=$USERNAME --ask-password -O "$zip" https://ai.vub.ac.be/svn/corpora/CLEVR-v1.0.zip
unzip -d "$dest" "$zip" && f=("$dest"/*) && mv "$dest"/*/* "$dest" && rmdir "${f[@]}"
rm "$zip"