#!/bin/bash

POSITIONAL_ARGS=()

while [[ $# -gt 0 ]]; do
  case $1 in
    -u|--user)
      USERNAME="$2"
      shift
      shift
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
    *)
      POSITIONAL_ARGS+=("$1") # save positional arg
      shift # past argument
      ;;
  esac
done

set -- "${POSITIONAL_ARGS[@]}" # restore positional parameters

echo "Fetching MNIST images and dialogs from the corpora SVN..."
brew install wget --quiet
mkdir -p data/mnist_dialog
wget --user=$USERNAME --ask-password -O data/mnist_dialog/MNIST-Dialog.zip https://ai.vub.ac.be/svn/corpora/MNIST-Dialog.zip
unzip -q data/mnist_dialog/MNIST-Dialog.zip -d data/mnist_dialog/
mv data/mnist_dialog/MNIST-Dialog/* data/mnist_dialog/
rm data/mnist_dialog/MNIST-Dialog.zip
rm -r data/mnist_dialog/MNIST-Dialog