#!/bin/bash

POSITIONAL_ARGS=()

while [[ $# -gt 0 ]]; do
  case $1 in
    -u|--user)
      USERNAME="$2"
      shift
      shift
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
    *)
      POSITIONAL_ARGS+=("$1") # save positional arg
      shift # past argument
      ;;
  esac
done

set -- "${POSITIONAL_ARGS[@]}" # restore positional parameters

echo "Fetching pretrained models..."
brew install wget --quiet
mkdir -p models/
wget --user=$USERNAME --ask-password -O models/trained_modules.zip https://ai.vub.ac.be/svn/corpora/neural-modules/trained-modules.zip 
unzip -q models/trained_modules.zip -d models/
rm models/trained_modules.zip