import os

from nmn.datasets.experiment import Experiment, UnsupportedExperimentError


def get_images(experiment, split):
    if experiment == Experiment.CLEVR or experiment == Experiment.CLEVR_DIALOG:
        return f"data/clevr/images/{split}/"
    elif experiment == Experiment.MNIST_DIALOG:
        return f"data/mnist_dialog/images/{split}/"
    else:
        raise UnsupportedExperimentError(experiment)


def get_scenes(experiment, split, module_name):
    dataset_dir = f"data/{experiment}/module_data"
    dir = os.path.join(dataset_dir, module_name)
    return os.path.join(dir, f"{split}.json")


def get_clevr_questions():
    return "data/clevr/questions/CLEVR_val_questions.json"


def get_model_dir(experiment):
    return f"models/{experiment}/backwards_compatible/"
